/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2008 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.blackberry.helper;

import javax.microedition.pim.PIMException;
import javax.microedition.pim.PIMItem;
import javax.microedition.pim.PIMList;
import javax.microedition.pim.ToDoList;
import javax.microedition.pim.ToDo;

import net.rim.blackberry.api.pdap.BlackBerryPIMList;

public abstract class TaskHelper extends PIMItemHelper
{    

    public TaskHelper(PIMList list) 
    {
        super(list);
    }
    
    /*
     * (non-Javadoc)
     * @see com.funambol.blackberry.helper.PIMItemHelper#createPIMItem(PIMList pimlist)
     */
    public PIMItem createItem() throws PIMException
    {
        ToDoList list = getToDoList();
        if (list != null)
        {
            return list.createToDo();
        }
        return null;
    }
    
    protected ToDoList getToDoList()
    {
        PIMList list = getPIMList();
        if (list != null && list instanceof ToDoList)
        {
            return (ToDoList)list;
        }
        return null;
    }
    
    
    public boolean isInSyncRange(PIMItem _item) throws PIMException
    {
        /*
        long NOW = System.currentTimeMillis();
        Calendar start = PIMItemHelper.getFieldDate(pimlist,_item,BlackBerryToDo.DUE,false,false,true);
        if (start!=null)
        {
            if (start.getTime().getTime() > (NOW+this.limitFuture*PIMItemHelper.MONTH_FACTOR))
            {
                return false;
            }
            else
            {
                RepeatRule rrule = ((BlackBerryToDo)_item).getRepeat();
                if (rrule==null)
                {
                    if (start.getTime().getTime() < (NOW-this.limitPast*PIMItemHelper.MONTH_FACTOR))
                    {
                        return false;
                    }                    
                }
                else
                {
                    Calendar end = SIFRepeatRuleHelper.getEndDate(rrule,true);
                    if (end == null)
                    {
                        end = Calendar.getInstance();
                        end.setTime(new Date(NOW));
                    }
                    if (end.getTime().getTime() < (NOW-this.limitPast*PIMItemHelper.MONTH_FACTOR))
                    {
                        return false;
                    }
                }
            }
        }*/
        return true;
    }
    
    public boolean deleteItem(PIMItem item) throws PIMException
    {
        ToDoList list = getToDoList();
        if (list != null &&
                item != null &&
                item instanceof ToDo &&
                isInSyncRange(item))
        {
            list.removeToDo((ToDo)item);
            return true;
        }
        return false;
    }

}
