/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2008 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol". 
 */

package com.funambol.blackberry.source;

import java.util.Enumeration;
import java.util.Vector;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

import com.funambol.syncml.spds.SourceConfig;
import com.funambol.syncml.spds.SyncItem;
import com.funambol.syncml.spds.SyncSource;
import com.funambol.syncml.spds.SyncException;

import com.funambol.util.Log;

import com.funambol.storage.StringKeyValueFileStore;
import com.funambol.syncml.client.CacheTracker;
import com.funambol.storage.StringKeyValueStore;
import com.funambol.syncml.client.ChangesTracker;

public class PhotoTracker extends CacheTracker {

    private String directory;

    public PhotoTracker(StringKeyValueStore keyStore, String directory) {
        super(keyStore);
        this.directory = directory;
    }

    protected String computeFingerprint(SyncItem item) {
        Log.trace("[PhotoTracker.computeFingerprint]");
        // We use the file size as fingerprint
        // This is not very accurate, but we do not expect pictures to be
        // changed on the device
        String file = directory + "/" + item.getKey();
        FileConnection fc = null;
        long size = 0;
        try {
            fc = (FileConnection) Connector.open(directory, Connector.READ);
            size = fc.fileSize();
        } catch(Exception e) {
        } finally {
            if (fc != null) {
                try {
                    fc.close();
                } catch (Exception e) {
                }
            }
        }
        return "" + size;
    }
}


