/**
 * 
 */
package com.funambol.util.appenders;

import net.rim.device.api.system.EventLogger;

import com.funambol.blackberry.BBVersion;
import com.funambol.storage.DataAccessException;
import com.funambol.util.Appender;
import com.funambol.util.StaticDataHelper;

public class BlackberryEventLogAppender implements Appender {

    private final static long guid = 0x948b87e2ee064ebeL;
    private String appName;

    public BlackberryEventLogAppender(String appName) {
        this.appName = appName;
    }

    public void closeLogFile() {

    }

    public void deleteLogFile() {
    }

    public void initLogFile() {

        try {
            EventLogger.register(guid, appName + " " + BBVersion.VERSION,
                    EventLogger.VIEWER_STRING);
        } catch (final Throwable t) {
            System.out.println(">>> Exception by registering the event logger:\n"
                    + ">>> Error message: " + t.getMessage() + "\n" + ">>> Short description: "
                    + t.toString() + "\n");
            t.printStackTrace();
        }
    }

    public void openLogFile() {
    }

    public void writeLogMessage(String level, String msg) throws DataAccessException {
        StringBuffer message = new StringBuffer();
        message.append("[").append(level).append("] ").append(msg);
        msg = message.toString();

        try {
            EventLogger.logEvent(guid, msg.getBytes());
        } catch (final Throwable tt) {
            System.out.println(">>> Exception by registering the event logger:\n"
                    + ">>> Error message: " + tt.getMessage() + "\n"
                    + ">>> Short description: " + tt.toString() + "\n");
            tt.printStackTrace();
        }

    }

}
