/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2008 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol". 
 */

package com.funambol.util;

import com.funambol.blackberry.*;
import com.funambol.util.Log;
import com.funambol.util.SimpleXMLParser.OneLevelHandler;
import jmunit.framework.cldc10.TestCase;

public class SimpleXMLParserTest extends TestCase {
    
    private ConfigData cd = null;
    
    public SimpleXMLParserTest() {
        super(1, "SimpleXMLParserTest");
        Log.setLogLevel(Log.INFO);
    }
    
    public void test(int testNumber) throws Throwable {
        
        switch(testNumber) {
            case 0:
                testDecodeUtf8();
                break;
            default:
                break;
        }
    }
    
    public void testDecodeUtf8() throws Exception {
        try {
            String string = "à è é ì ò ù ç";
            OneLevelHandler olh = new OneLevelHandler("");
            String result = olh.decodeUtf8(string);
            assertEquals(result,string);
        } catch (Throwable ex) {
            Log.error("Error in decodeUtf8Test : " +ex.getMessage());
        }
    }
    
 }

